package madqba.awt;

import java.awt.Button;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;


/**
 * CmdButton is a simple button which performs a command after beeing clicked.
 *
 * @author Jakub Madej
 */
public class CmdButton extends Button implements ActionListener {
    private Command cmd;

    /**
     * Creates a new CmdButton object.
     *
     * @param title title
     * @param cmd Command object
     */
    public CmdButton(String title, Command cmd) {
        super(title);
        this.cmd = cmd;
        addActionListener(this);
    }

    /**
     * This function is called whenever an action is performed.
     *
     * @param e ActionEvent object
     */
    public void actionPerformed(ActionEvent e) {
        cmd.execute();
    }
}
