package madqba.awt.chat;

import madqba.awt.ChatPanel;
import madqba.awt.CmdButton;
import madqba.awt.Command;
import madqba.awt.Nicktf;
import madqba.awt.Progress;
import madqba.awt.SMenu;
import madqba.awt.SmileButton;
import madqba.awt.Smiles;
import madqba.awt.TextCommand;
import madqba.awt.TextEntry;

import madqba.net.ClientProcess;
import madqba.net.ConnectProcess;

import org.apache.log4j.FileAppender;
import org.apache.log4j.Logger;
import org.apache.log4j.PatternLayout;

import java.awt.Button;
import java.awt.Color;
import java.awt.Container;
import java.awt.Font;
import java.awt.Frame;
import java.awt.Insets;
import java.awt.Label;
import java.awt.List;
import java.awt.TextField;

import java.io.File;
import java.io.FileInputStream;
import java.io.OutputStreamWriter;

import java.net.Socket;

import java.util.Enumeration;
import java.util.Properties;
import java.util.Vector;


/**
 * This class is a root class of the whole system. It creates all visible
 * components as well as threads and menages communication between them.
 *
 * @author Jakub Madej
 */
public class Mediator {
    public static final int WIDTH = 610;
    public static final int HEIGHT = 350;
    private static final int COMPONENTHEIGHT = 20;
    private static final int ROW1X = 100;
    private static final int ROW1Y = 15;
    private static final int ROW2X = 150;
    private static final int ROW2Y = 45;
    private static final int ROW3X = 250;
    private static final int ROW3Y = 65;
    private static final int ROW4X = 350;
    private static final int ROW4Y = 180;
    private static final int ROW5X = 350;
    private static final int ROW5Y = 200;
    private static final int ABOUTX = 322;
    private static final int ABOUTY = 33;
    private static final int ABOUTWIDTH = 320;
    private static final int SPACE = 5;
    private static final int NENTRYY = 25;
    private static final int NENTRYWIDTH = 135;
    private static final int SMSPACE = 2;
    private static final int CHPANELW = 115;
    private static final int CHPANELH = 35;
    private static final int LISTX = 105;
    private static final int LISTW = 100;
    private static final int LISTH = 35;
    private static final int PRIVX = 105;
    private static final int PRIVY = 25;
    private static final int PRIVW = 50;
    private static final int KTOTOX = 55;
    private static final int KTOTOY = 25;
    private static final int KTOTOW = 50;
    private static final Color COLOR1 = new Color(91, 170, 255);
    private static final Color COLOR2 = new Color(242, 217, 138);
    private static final Color COLOR3 = new Color(158, 204, 255);
    private static final Font FONT_NORMAL = new Font("Default", Font.PLAIN, 12);
    private static final Font FONT_SMALL = new Font("Default", Font.PLAIN, 9);
    private static final Font FONT_BIG = new Font("Default", Font.BOLD, 11);
    private String serv;
    private String port;
    private String chan;
    private String pass;
    private String info;
    private Label wprowadz;
    private CmdButton polacz;
    private CmdButton poniechaj;
    private TextField nicktf;
    private Label status = new Label("", Label.CENTER);
    private Progress progress = new Progress();
    private Label about = new Label(
            "java irc client v1.0 (c) 2003 Jakub Madej <madqba@atari.pl>");
    private Label statuslab;
    private TextEntry nickEntry = new TextEntry(new TextCommand() {
                public void execute(String txt) {
                    writeToChan(txt);
                }
            }, this);
    private SmileButton sbutton;
    private SMenu smenu;
    private ChatPanel chatpanel;
    private List list = new List();
    private CmdButton priv;
    private CmdButton ktoto;
    private ConnectProcess cp;
    private OutputStreamWriter out;
    private Socket s;
    private Vector privlist = new Vector();
    private Smiles smiles;
    private Properties properties = new Properties();

    /**
     * Creates a new Mediator object.
     *
     * @param c root Container
     * @param serv server name
     * @param port port to connect to
     * @param chan channel to join
     * @param pass bnc password
     */
    public Mediator(Container c, String serv, String port, String chan,
        String pass) {
        {
            Logger log = Logger.getRootLogger();
            FileAppender file = new FileAppender();
            file.setFile("irc.log");
            file.setAppend(false);
            file.setLayout(new PatternLayout());
            file.activateOptions();
            log.addAppender(file);
        }

        int x = 0;
        int y = 0;
        c.setLayout(null);

        this.serv = serv;
        this.port = port;
        this.chan = chan;
        this.pass = pass;

        if (c instanceof Frame) {
            c.setVisible(true);
            ((Frame) c).setResizable(false);
            c.setSize(WIDTH + c.getInsets().left + c.getInsets().right,
                HEIGHT + c.getInsets().bottom + c.getInsets().top);
            x = c.getInsets().left;
            y = c.getInsets().top;

            try {
		properties.load(ClassLoader.getSystemResourceAsStream(".properties"));
            } catch (Exception ex) { }
        } else {
        }

        c.setBackground(COLOR1);
        smiles = new Smiles(c);

        wprowadz = new Label(properties.getProperty("wprowadz"));
        wprowadz.setBounds((x + (WIDTH / 2)) - ROW1X, y + ROW1Y, ROW1X,
            COMPONENTHEIGHT);
        wprowadz.setFont(FONT_NORMAL);
        c.add(wprowadz);

        polacz = new CmdButton(properties.getProperty("polacz"),
                new Command() {
                    public void execute() {
                        polacz();
                    }
                });
        polacz.setBounds((x + (WIDTH / 2)) - ROW2X, y + ROW2Y, ROW2X,
            COMPONENTHEIGHT);
        polacz.setEnabled(false);
        polacz.setFont(FONT_NORMAL);
        c.add(polacz);

	nicktf = new Nicktf(this);
        nicktf.setBounds(x + (WIDTH / 2), y + ROW1Y, ROW1X, COMPONENTHEIGHT);
        nicktf.setFont(FONT_NORMAL);
        c.add(nicktf);

        poniechaj = new CmdButton(properties.getProperty("poniechaj"),
                new Command() {
                    public void execute() {
                        poniechaj();
                    }
                });
        poniechaj.setBounds(x + (WIDTH / 2), y + ROW2Y, ROW2X, COMPONENTHEIGHT);
        poniechaj.setEnabled(false);
        poniechaj.setFont(FONT_NORMAL);
        c.add(poniechaj);

        progress.setBounds((x + (WIDTH / 2)) - (ROW3X / 2), y + ROW3Y, ROW3X,
            COMPONENTHEIGHT * 3);
        c.add(progress);

        statuslab = new Label(properties.getProperty("status"), Label.CENTER);
        statuslab.setBounds((x + (WIDTH / 2)) - (ROW4X / 2), y + ROW4Y, ROW4X,
            COMPONENTHEIGHT);
        statuslab.setFont(FONT_NORMAL);
        c.add(statuslab);

        status.setBounds((x + (WIDTH / 2)) - (ROW5X / 2), y + ROW5Y, ROW5X,
            COMPONENTHEIGHT);
        status.setBackground(COLOR2);
        status.setFont(FONT_NORMAL);
        c.add(status);

        about.setBounds((x + WIDTH) - ABOUTX, (y + HEIGHT) - ABOUTY,
            ABOUTWIDTH, COMPONENTHEIGHT);
        about.setBackground(COLOR1);
        about.setFont(FONT_SMALL);
        c.add(about);

        nickEntry.setBounds(x + SPACE, (y + HEIGHT) - NENTRYY,
            WIDTH - NENTRYWIDTH, COMPONENTHEIGHT);
        nickEntry.setVisible(false);
        nickEntry.setBackground(COLOR3);
        nickEntry.setFont(FONT_NORMAL);
        c.add(nickEntry);

        chatpanel = new ChatPanel(this, WIDTH - CHPANELW, HEIGHT - CHPANELH);
        chatpanel.setLocation(x + SPACE, y + SPACE);
        chatpanel.setVisible(false);
        c.add(chatpanel);

        list.setBounds((x + WIDTH) - LISTX, y + SPACE, LISTW, HEIGHT - LISTH);
        list.setVisible(false);
        list.setBackground(COLOR3);
        list.setFont(FONT_BIG);
        c.add(list);

        priv = new CmdButton(properties.getProperty("priv"),
                new Command() {
                    public void execute() {
                        priv();
                    }
                });
        priv.setBounds((x + WIDTH) - PRIVX, (y + HEIGHT) - PRIVY, PRIVW,
            COMPONENTHEIGHT);
        priv.setVisible(false);
        priv.setFont(FONT_NORMAL);
        c.add(priv);

        ktoto = new CmdButton(properties.getProperty("ktoto"),
                new Command() {
                    public void execute() {
                        ktoto();
                    }
                });
        ktoto.setBounds((x + WIDTH) - KTOTOX, (y + HEIGHT) - KTOTOY, KTOTOW,
            COMPONENTHEIGHT);
        ktoto.setVisible(false);
        ktoto.setFont(FONT_NORMAL);
        c.add(ktoto);

        smenu = new SMenu(this, nickEntry);
        smenu.setLocation(list.getLocation().x + SMSPACE,
            (list.getLocation().y + list.getSize().height) -
            smenu.getSize().height - SMSPACE);
        smenu.setVisible(false);
        c.add(smenu);

        sbutton = new SmileButton(smiles.getSmile1(), smenu);
        sbutton.setBounds(x + SPACE + nickEntry.getSize().width,
            nickEntry.getBounds().y, COMPONENTHEIGHT, COMPONENTHEIGHT);
        sbutton.setVisible(false);
        c.add(sbutton);

        nicktf.requestFocus();
    }

    /**
     * Shows/hides components which belong to two different sets. One set makes
     * the logging screen, and the other chat screen.
     *
     * @param vis if true logging screen will be shown, otherwise chat screen
     * will appear.
     */
    private void setComponentsVis(boolean vis) {
        wprowadz.setVisible(vis);
        polacz.setVisible(vis);
        poniechaj.setVisible(vis);
        nicktf.setVisible(vis);
        status.setVisible(vis);
        about.setVisible(vis);
        progress.setVisible(vis);
        statuslab.setVisible(vis);

        nickEntry.setVisible(!vis);
        sbutton.setVisible(!vis);
        chatpanel.setVisible(!vis);
        list.setVisible(!vis);
        priv.setVisible(!vis);
        ktoto.setVisible(!vis);
    }

    /**
     * Switches the client from logging mode to chat mode.
     *
     * @param topic topic of conversation
     * @param out OutputStreamWriter object
     * @param s Socket object
     */
    public void chatMode(String topic, OutputStreamWriter out, Socket s) {
        this.s = s;
        this.out = out;
        setComponentsVis(false);
        chatpanel.setText(properties.getProperty("witaj") + ", " +
            nicktf.getText() + ", " + properties.getProperty("nakanale") + " " +
            chan + "!");

        if (info != null)
            chatpanel.append(info);

        if (topic != null)
            chatpanel.append(properties.getProperty("temat") + ": " + topic);

        nickEntry.requestFocus();
        new ClientProcess(this, s);
    }

    /**
     * Switches the client back to logging mode.
     */
    private void connMode() {
        setComponentsVis(true);
    }

    /**
     * Enables or disables acces to connect button.
     *
     * @param b if true user will be able to connect by clicking on the proper
     * button, if not it won't be possible
     */
    public void polaczSetEnabled(boolean b) {
        polacz.setEnabled(b);
    }

    /**
     * Starts a new thread which attempts to connect to the server.
     */
    public void polacz() {
        poniechaj.setEnabled(true);
        polacz.setEnabled(false);
        nicktf.setEnabled(false);
        progress.start();
        status.setText(properties.getProperty("laczenie"));
        cp = new ConnectProcess(this, serv, Integer.parseInt(port), chan,
                nicktf.getText(), pass);
    }

    /**
     * Cancels the connect thread.
     */
    public void poniechaj() {
        polacz.setEnabled(true);
        poniechaj.setEnabled(false);
        nicktf.setEnabled(true);
        progress.stop();
        cp.interrupt();
        status.setText("");
    }

    /**
     * This method is invoked to indicate that the connection failed.
     *
     * @param s Socket object
     */
    public void connError(Socket s) {
        try {
            s.close();
        } catch (Exception ex) {
        }

        poniechaj();
        setStatus(properties.getProperty("nieud"));
    }

    /**
     * Sets String displayed on the status label.
     *
     * @param s text to be displayed
     */
    public void setStatus(String s) {
        status.setText(s);
    }

    /**
     * Clears list of nicknames.
     */
    public void clearList() {
        list.clear();
    }

    /**
     * Adds a new nickname to the list.
     *
     * @param nick nickname to be added
     */
    public void addToList(String nick) {
        if (list.getItemCount() == 0)
            list.add(nick);
        else {
            for (int i = 0; i < list.getItemCount(); i++)
                if (nick.toLowerCase().compareTo(list.getItem(i).toLowerCase()) < 0) {
                    list.add(nick, i);

                    return;
                }

            list.add(nick);
        }
    }

    /**
     * Returns user's nickname.
     *
     * @return user's nickname.
     */
    public String getNick() {
        return nicktf.getText();
    }

    /**
     * Sends a new user message to the channel. The message will be displayed on
     * the ChatPanel and send to the proper
     * Socket.
     *
     * @param mesg message to send
     */
    public void writeToChan(String mesg) {
        writeToSock(mesg, chan);
        chatpanel.append(mesg, nicktf.getText());
    }

    /**
     * Sends a new message to the server.
     *
     * @param mesg the message
     * @param where channel name or nickname
     */
    public void writeToSock(String mesg, String where) {
        try {
            out.write("PRIVMSG " + where + " :" + mesg + "\r\n");
            out.flush();
        } catch (Exception ex) {
            connLost();

            return;
        }
    }

    /**
     * This method is invoked when the client looses connection.
     */
    public void connLost() {
        try {
            s.close();
        } catch (Exception ex) {
        }

        poniechaj();
        connMode();
        setStatus(properties.getProperty("polprzerw"));

        Enumeration en = privlist.elements();

        while (en.hasMoreElements())
            ((PrivChat) en.nextElement()).setVisible(false);

        privlist.removeAllElements();
    }

    /**
     * Returns list of all nicknames avaible on the channel.
     *
     * @return List object
     */
    public List getList() {
        return list;
    }

    /**
     * Starts a new private conversation with a person selected on the nicks
     * list.
     */
    public void priv() {
        if (list.getSelectedIndex() == -1)
            chatpanel.append(properties.getProperty("wybierz"));
        else {
            String sender = list.getSelectedItem();

            if (sender.equals(nicktf.getText())) {
                chatpanel.append("!! " + properties.getProperty("proba") +
                    " !!");

                return;
            }

            PrivChat priv = null;
            Enumeration en = privlist.elements();

            while (en.hasMoreElements()) {
                Object obj = en.nextElement();

                if (obj.toString().equals(sender)) {
                    priv = (PrivChat) obj;

                    break;
                }
            }

            if (priv == null) {
                priv = new PrivChat(this, sender);
                privlist.insertElementAt(priv, 0);
            }

            priv.show();
        }
    }

    /**
     * Displays some information about a person selected on the nicks list.
     */
    public void ktoto() {
        if (list.getSelectedIndex() == -1)
            chatpanel.append(properties.getProperty("wybierz"));
        else {
            try {
                out.write("WHOIS " + list.getSelectedItem() + "\r\n");
                out.flush();
            } catch (Exception ex) {
                connLost();

                return;
            }
        }
    }

    /**
     * Displays a new message on the ChatPanel.
     *
     * @param msg message to be appended
     */
    public void addMsg(String msg) {
        chatpanel.append(msg);
    }

    /**
     * Displays a new user message on the ChatPanel.
     *
     * @param nick nickname of person who speeches
     * @param msg message
     */
    public void addMsg(String nick, String msg) {
        chatpanel.append(msg, nick);
    }

    /**
     * Removes a single person from nikcs list.
     *
     * @param nick nickname to be removed
     */
    public void removeFromList(String nick) {
        list.remove(nick);
    }

    /**
     * Returns Vector which holds all active private chats.
     *
     * @return Vector object
     */
    public Vector getPrivList() {
        return privlist;
    }

    /**
     * Returns the current channel's name.
     *
     * @return name of the channel
     */
    public String getChan() {
        return chan;
    }

    /**
     * Returns Smiles object.
     *
     * @return Smiles object
     */
    public Smiles getSmiles() {
        return smiles;
    }

    /**
     * Disconnects the client from server.
     */
    public void disconnect() {
        try {
            out.write("QUIT :Java irc client (c) 2003 madqba\r\n");
            out.flush();
            s.close();
        } catch (Exception ex) {
        }
    }

    /**
     * Returns program's properties.
     *
     * @return Properties object
     */
    public Properties getProperties() {
        return properties;
    }
}
